xonotic/misc/tools/xonotic-map-compiler-autobuild

347 lines
7.9 KiB
Plaintext
Raw Normal View History

2010-05-06 14:58:03 +00:00
#!/bin/sh
2010-05-27 13:31:54 +00:00
set -e
2010-05-27 11:17:13 +00:00
bspdir="$PWD/data"
2010-09-29 17:41:38 +00:00
url_http=http://beta.xonotic.org/autobuild-bsp/
2010-09-16 04:35:57 +00:00
url_ssh=xonotic-beta:autobuild-bsp/
2010-09-29 12:43:59 +00:00
build_cachedir="$HOME/xonotic-map-compiler.cache/"
screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
2010-09-29 12:48:44 +00:00
build_override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
2010-10-02 11:26:21 +00:00
screenshot_override="9 600 +g_ctf 1"
2010-05-27 11:17:13 +00:00
2010-09-29 12:53:17 +00:00
getthemap_fail=false
2010-05-27 11:17:13 +00:00
allmaps()
{
commithash=$1
shift
for F in `git ls-files "$commithash" -- maps/\*.map.options`; do
2010-05-06 14:58:03 +00:00
M=${F#maps/}
M=${M%.map.options}
blobhash=`git rev-parse --revs-only "$commithash:maps/$M.map.options" || true`-`git rev-parse --revs-only "$commithash:maps/$M.map" || true`
case "$blobhash" in
-*)
;;
*-)
;;
*)
"$@" "$M" "$blobhash" "$commithash"
;;
esac
2010-05-06 14:58:03 +00:00
done
2010-05-27 11:17:13 +00:00
}
pre2spam()
{
map=$1
url=$2
branch=$3
hash=$4
branch=${branch##refs/heads/}
branch=${branch##refs/remotes/}
branch=${branch##origin/}
hash=`echo "$hash" | cut -c 1-7`
echo "[$branch $hash] starting map compile of $map"
}
2010-09-29 12:43:59 +00:00
ss2spam()
{
map=$1
url=$2
branch=$3
hash=$4
2010-09-29 12:48:44 +00:00
status=$5
2010-09-29 12:43:59 +00:00
branch=${branch##refs/heads/}
branch=${branch##refs/remotes/}
branch=${branch##origin/}
hash=`echo "$hash" | cut -c 1-7`
2010-09-29 12:48:44 +00:00
s_error=
if [ "$status" -ne 0 ]; then
s_error="exited with status $status"
fi
if [ -n "$s_error" ]; then
echo "[$branch $hash] 4screenshots of $map could not be made: $s_error"
else
echo "[$branch $hash] screenshots of $map are available on $url"
fi
2010-09-29 12:43:59 +00:00
}
log2spam()
{
map=$1
url=$2
branch=$3
hash=$4
status=$5
2010-07-19 12:40:45 +00:00
time=$6
hash=`echo "$hash" | cut -c 1-7`
branch=${branch##refs/heads/}
branch=${branch##refs/remotes/}
branch=${branch##origin/}
s_samplesize=
s_failshaders=
s_leaked=
s_error=
if [ "$status" -ne 0 ]; then
s_error="exited with status $status"
fi
while IFS= read -r L; do
case "$L" in
WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
s=${L##* }
if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
s_samplesize=$s
fi
;;
WARNING:\ Couldn\'t\ find\ image\ for\ shader\ textures/NULL)
# radiant stupid
;;
WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
s_failshaders="$s_failshaders ${L##* }"
;;
'******* leaked *******')
s_leaked=1
;;
'************ ERROR ************')
IFS= read -r s_error
;;
esac
done
2010-06-15 15:41:08 +00:00
s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
s_failshaders=${s_failshaders# }
if [ -n "$s_error" ]; then
echo -n "[$branch $hash] 4failed"
else
echo -n "[$branch $hash] finished"
fi
2010-07-19 12:40:45 +00:00
echo -n " map compile of $map ($url): $time sec"
if [ -n "$s_samplesize" ]; then
echo -n ", FIX samplesize >= $s_samplesize"
fi
if [ -n "$s_failshaders" ]; then
if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
fi
echo -n ", FIX shaders $s_failshaders"
fi
if [ -n "$s_leaked" ]; then
echo -n ", FIX LEAK"
fi
if [ -n "$s_error" ]; then
s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
echo -n ", ERROR: $s_error"
fi
echo
}
2010-05-27 11:17:13 +00:00
buildthemap()
{
REFNAME=$1
url=$2
M=$3
blobhash=$4
HASH=$5
if HEAD "$url$M-$blobhash.pk3"; then
2010-05-27 11:17:13 +00:00
continue
fi
git reset --hard
git clean -xfd
git checkout -f "$HASH"
if [ -n "$IRCSPAM" ]; then
pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
fi
2010-07-21 13:05:51 +00:00
t0=`date +%s`
2010-05-27 11:17:13 +00:00
(
cd maps
2010-09-29 12:48:44 +00:00
../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $build_override > "$M.log"
2010-05-27 11:17:13 +00:00
)
2010-07-21 13:05:51 +00:00
t1=`date +%s`
2010-07-19 12:40:45 +00:00
dt=$(($t1 - $t0))
status=$?
2010-07-17 13:40:04 +00:00
if [ -n "$IRCSPAM" ]; then
2010-07-19 12:40:45 +00:00
cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" "$status" "$dt" > "maps/$M.irc"
2010-07-17 13:40:04 +00:00
fi
2010-09-16 04:16:44 +00:00
zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
if [ -n "$IRCSPAM" ]; then
2010-07-17 13:40:04 +00:00
$IRCSPAM < "maps/$M.irc"
fi
2010-05-27 11:17:13 +00:00
}
2010-09-29 12:43:59 +00:00
screenshotthemap()
{
REFNAME=$1
url=$2
M=$3
blobhash=$4
HASH=$5
2010-09-29 12:43:59 +00:00
if HEAD "$url$M-$blobhash/"; then
continue
fi
git reset --hard
git clean -xfd
git checkout -f "$HASH"
2010-09-29 12:43:59 +00:00
rm -rf ~/.xonotic
(
2010-09-29 12:54:25 +00:00
cd ../..
2010-09-29 13:17:08 +00:00
if [ -n "$DISPLAY" ]; then
misc/tools/xonotic-map-screenshot "$M" $screenshot_override +"scr_screenshot_name \"$M-\""
else
startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"scr_screenshot_name \"$M-\"" -- :8
fi
2010-09-29 12:43:59 +00:00
)
2010-09-29 12:48:44 +00:00
if ! mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
if [ -n "$IRCSPAM" ]; then
2010-10-01 22:11:21 +00:00
#ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$HASH" 1 > "maps/$M.ircss"
ss2spam "$M" "$url?d" "$REFNAME" "$HASH" 1 > "maps/$M.ircss"
2010-09-29 12:48:44 +00:00
fi
return 1
fi
2010-09-29 12:43:59 +00:00
if [ -n "$IRCSPAM" ]; then
2010-10-01 22:11:21 +00:00
#ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$HASH" 0 > "maps/$M.ircss"
ss2spam "$M" "$url?d" "$REFNAME" "$HASH" 0 > "maps/$M.ircss"
2010-09-29 12:43:59 +00:00
fi
2010-10-01 21:57:49 +00:00
chmod 1777 "$M-$blobhash"
2010-09-29 12:43:59 +00:00
ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
rsync -vaSHP "$M-$blobhash" "$url_ssh"
rsync -vaSHP "$M" "$url_ssh""latest/"
if [ -n "$IRCSPAM" ]; then
$IRCSPAM < "maps/$M.ircss"
fi
}
2010-05-27 11:17:13 +00:00
getthemap()
{
url=$1
bspdir_old=$2
bspdir=$3
M=$4
blobhash=$5
HASH=$6
2010-05-27 13:31:36 +00:00
if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
2010-05-27 11:17:13 +00:00
continue
fi
if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
rm -f "$bspdir/$M-$blobhash.pk3"
echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
2010-09-29 13:11:33 +00:00
getthemap_fail=true
return 0
fi
2010-05-27 11:17:13 +00:00
fi
if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
rm -f "$bspdir/$M-$blobhash.pk3"
echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
2010-09-29 12:53:17 +00:00
getthemap_fail=true
2010-07-18 17:08:13 +00:00
return 0
2010-05-27 11:17:13 +00:00
fi
}
indexthemap()
{
REFNAME=$1
M=$2
blobhash=$3
HASH=$4
echo "$M $blobhash $HASH $REFNAME"
}
rundownload()
{
mkdir -p "$bspdir" "$bspdir.old"
for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
if [ -e "$b" ]; then
mv "$b" "$bspdir.old"/
fi
done
cd data/xonotic-maps.pk3dir
allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
cd ../..
}
2010-10-05 12:03:41 +00:00
branches()
{
git for-each-ref 'refs/remotes' | grep -vE ' refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
}
runmakeindex()
{
cd data/xonotic-maps.pk3dir
branches | while read -r HASH TYPE REFNAME; do
allmaps "$HASH" indexthemap "$REFNAME"
done
}
2010-05-27 11:17:13 +00:00
case "$1" in
build)
cd data/xonotic-maps.pk3dir
2010-10-05 12:03:41 +00:00
branches | while read -r HASH TYPE REFNAME; do
2010-09-29 12:43:59 +00:00
if [ -f "$build_cachedir/$HASH" ]; then
continue
fi
allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
2010-09-29 12:43:59 +00:00
touch "$build_cachedir/$HASH"
done
git checkout -f master
;;
screenshot)
cd data/xonotic-maps.pk3dir
runmakeindex > branches.idx.new
rsync -vaSHP "$branches.idx.new" "$url_ssh""branches.idx.new"
rm -f branches.idx.new
2010-10-05 12:03:41 +00:00
branches | while read -r HASH TYPE REFNAME; do
2010-09-29 12:43:59 +00:00
if [ -f "$screenshot_cachedir/$HASH" ]; then
continue
fi
2010-09-29 13:34:16 +00:00
rundownload
if $getthemap_fail; then
continue
fi
2010-09-29 13:34:16 +00:00
cd data/xonotic-maps.pk3dir
allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
touch "$screenshot_cachedir/$HASH"
2010-05-27 11:17:13 +00:00
done
2010-08-14 00:47:43 +00:00
git checkout -f master
2010-05-27 11:17:13 +00:00
;;
makeindex)
2010-10-05 12:03:41 +00:00
runmakeindex
;;
download)
rundownload
echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
ls -l "$bspdir.old" || true
;;
download-latest)
mkdir -p "$bspdir"
cd "$bspdir"
rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
2010-09-29 17:41:38 +00:00
wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
2010-05-27 11:17:13 +00:00
;;
log2spam-test)
log2spam "mapname" "http://mapurl" "branch" "commit" "0"
2010-05-27 11:17:13 +00:00
;;
esac